#include "ritas.h"
#include "ritas_rb.h"
#include "ritas_bc.h"
#include "ritas_mvc.h"
#include "ritas_vc.h"
#include "ritas_ab.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

#define RB	0
#define BC	1
#define MVC	2
#define VC	3
#define AB	4

#define BUF_S 32
#define VALUE_S 10

#define BASE_PORT 4666

struct bench {
	u_char protocol;
	u_short id;
};

struct rb_bench {
	u_char protocol;
	u_short id;
	u_short sender;
	u_short value_s;
};

struct bc_bench {
	u_char protocol;
	u_short id;
	u_short requests;
};

struct mvc_bench {
	u_char protocol;
	u_short id;
	u_short value_s;	
};

struct vc_bench {
	u_char protocol;
	u_short id;
	u_short value_s;	
};

struct ab_bench {
	u_char protocol;
	u_short id;
	short sender;
	u_short requests;
	u_short rate;
	u_short value_s;	
};

struct ctxmsg {
	ritas_t *ctx;
	struct ab_bench *msg;
};

int rb_bench(ritas_t *ctx, struct rb_bench *msg);
int bc_bench(ritas_t *ctx, struct bc_bench *msg);
int mvc_bench(ritas_t *ctx, struct mvc_bench *msg);
int vc_bench(ritas_t *ctx, struct vc_bench *msg);
int ab_bench(ritas_t *ctx, struct ab_bench *msg);
void ab_tx(struct ctxmsg *cm);
