
int libdit_mvector_init(libdit_t *ctx, libdit_mvector_t *mvec) {
	
	int i;
	
	mvec->length = libdit_group_size(ctx);
	
	mvec->index = malloc(sizeof(u_int *) * mvec->length);
	for(i = 0 ; i < mvec->length ; i++) {
		mvec->index[i] = NULL;
	}

}	

int libdit_mvector_destroy(libdit_mvector_t *mvec) {
	
	int i;
	
	for(i = 0 ; i < mvec->length ; i++) {
		if(!mvec->index[i])
			free(mvec->index[i]);
	}	
	free(mvec->index);
}

int libdit_mvector_add(libdit_mvector_t *mvec, struct libdit_msg *msg) {
	
	if(msg->proc_id <= mlist->length)
		if(!mvec->msg_index[msg->proc_id]) {
			mvec->msg_index[msg->proc_id] = malloc(sizeof(struct libdit_msg));
			memcpy(mvec->msg_index[msg->proc_id], msg, 
				sizeof(struct libdit_msg));
		}
}

int libdit_mvector_count_by_value(libdit_mvector_t *mvec, u_char type, 
	u_char *value, u_int value_size) {
	
	int i;
	int count = 0;
	
	for(i = 0 ; i < mvec.length ; i++) {
		if(mvec.index[i])
			if(mvec.index[i].value_size == value_size)
				if(!strncmp(mvec.index[i].value, value, value_size))
					count++;
	}
	
	return count;
}

int libdit_mvector_count_from(libdit_mvector_t *mvector, u_char type, 
	u_short proc_id) {
		
	int i;
	int count = 0;
	
	for(i = 0 ; i < mvec.length ; i++) {
		if(mvec.index[i])
			if(mvec.index[i].proc_id == proc_id)
				count++;
	}
	
	return count;
}	
		