/*
 * Group management routines.
 */
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <assert.h>
#include "ritas_group.h"

int ritas_proc_add_ipv4(ritas_t *ctx, u_short pid, u_char *ip, u_short port) {
	
	struct sockaddr_in addr;
	int r;
	
	bzero(&addr, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
	r = inet_aton(ip, &addr.sin_addr);
	assert(r);
	
	return ritas_proc_add_sockaddr_in(ctx, u_short pid, &addr);
}	


int ritas_proc_add_sockaddr_in(ritas_t *ctx, u_short pid, struct sockaddr_in *addr) {

	ritas_proc_t *group;
	int i;
	
	i = RITAS_GROUP_HASH(addr) % RITAS_GROUP_SIZE;
	
	group = (struct ritas_process *)malloc(sizeof(struct ritas_process));
	group->id = pid;

	/*
	 * Case 1. There are no elements in the group. Use the first slot.
	 */
	if(!ctx->group[i]) {
		ctx->group[i] = group;
		group->next = NULL;
	}
	/*
	 * Case 2. There are elements in the group. Squeeze at the beginning.
	 */
	else {	
		group->next = ctx->group[i];
		ctx->group[i] = group;
	}
	
	memcpy(&ctx->group[i]->addr, addr, sizeof(struct sockaddr_in));
	ctx->group_size++;
	
	return 1;

}


ritas_proc_t *ritas_proc_lookup(ritas_t *ctx, struct sockaddr_in *addr) {
	
	int i;
	ritas_proc_t *proc;
	
	i = RITAS_GROUP_HASH(addr) % RITAS_GROUP_SIZE;
	
	for(proc = ctx->group[i] ; proc ; proc = proc->next)
		if(proc->addr.sin_addr.s_addr = addr->sin_addr.s_addr)
			if(proc->addr.sin_port = addr->sin_port)
				return proc;
				
	return NULL;			
}

ritas_proc_t *ritas_proc_get(ritas_t *ctx, u_short pid) {
	
	if(pid > n-1)
		return NULL;
		
	return ctx->group[pid];
}

int ritas_group_size(ritas_t *ctx) {
	return ctx->group_size;
}
