#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#define SERV "194.117.20.194"
#define PORT 4666
#define MSG_SIZE 512
#define ROUNDS 50000

#define toLL(tv) ((tv.tv_sec*(long long)1000000)+tv.tv_usec)

int main(int argc, char **argv) {
	
	int s, i, n, total_sent, total_recv;
    struct sockaddr_in servaddr;	
	char msg[MSG_SIZE];
	struct timeval tv0, tv1;
	long long t0, t1;
	int type, flag;

	if(argc != 2) {
		exit(1);
	}
	
	if(!strncmp("udp", argv[1], 3)) {
		type = SOCK_DGRAM;
	}
	else if(!strncmp("tcp", argv[1], 3)) {
		type = SOCK_STREAM;
	}

	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(PORT);
	inet_pton(AF_INET, SERV, &servaddr.sin_addr);

	s = socket(AF_INET, type, 0);

	if(type = SOCK_STREAM) {
		flag = 1;
		setsockopt(s, IPPROTO_TCP, TCP_NODELAY, (char *)&flag, sizeof(int));
	}

	connect(s, (struct sockaddr *)&servaddr, sizeof(servaddr));
	
	total_sent = 0;
	total_recv = 0;
	gettimeofday(&tv0, NULL);
	for(i = 0 ; i < ROUNDS ; i++) {
		n = send(s, msg, MSG_SIZE, 0);
		if(n < 0) {
			perror("send()");
			exit(1);
		}
		total_sent += n;
		n = recv(s, &msg, MSG_SIZE, 0);
		if(n < 0) {
			perror("recv()");
			exit(1);
		}
		total_recv += n;
	}
	gettimeofday(&tv1, NULL);
	
	printf("t0 -> %d.%d\n", tv0.tv_sec, tv0.tv_usec);
	printf("t1 -> %d.%d\n", tv1.tv_sec, tv1.tv_usec);
	
	t0 = toLL(tv0);
	t1 = toLL(tv1);
	
	printf("Total bytes sent: %d\n", total_sent);	
	printf("Total bytes received: %d\n", total_recv);
	printf("diff: %ld\n", t1-t0);
	printf("Average latency: %d us\n", (t1-t0)/(ROUNDS*2));
	
	close(s);
}
