#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#define PORT 4666
#define MSG_SIZE 512
#define ROUNDS 50000

int main(int argc, char **argv) {
	
	int s, i, n, total_sent, total_recv, ns;
    struct sockaddr_in servaddr, cliaddr;
    socklen_t clilen;
	char msg[MSG_SIZE];
	int type, flag;

	if(argc != 2) {
		exit(1);
	}
	
	if(!strncmp("udp", argv[1], 3)) {
		type = SOCK_DGRAM;
	}
	else if(!strncmp("tcp", argv[1], 3)) {	
		type = SOCK_STREAM;
	}


	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(PORT);
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);

	ns = s = socket(AF_INET, type, 0);
	if(s == -1) {
		perror("socket()");
		exit(1);
	}
	n = bind(s, (struct sockaddr *)&servaddr, sizeof(servaddr));
	if(n == -1) {
		perror("bind()");
		exit(1);
	}

	clilen = sizeof(cliaddr);
	total_sent = 0;
	total_recv = 0;
	

	if(type == SOCK_STREAM) {
		n = listen(s, 5);
		if(n < 0) {
			perror("listen()");
			exit(1);
		}
		ns = accept(s, (struct sockaddr *)&cliaddr, &clilen);
		if(ns < 0) {
			perror("accept()");
			exit(1);
		}
		flag = 1;
		setsockopt(ns, IPPROTO_TCP, TCP_NODELAY, (char *)&flag, sizeof(int));
	}
	
	for(;;) {
		n = recvfrom(ns, &msg, MSG_SIZE, 0, (struct sockaddr *)&cliaddr, &clilen);
		if(n < 0) {
			perror("recv()");
			exit(1);
		}
		total_recv += n;

		n = sendto(ns, msg, MSG_SIZE, 0, (struct sockaddr *)&cliaddr, clilen);
		if(n < 0) {
			perror("send()");
			exit(1);
		}
		total_sent += n;
	}
	
	printf("Total bytes received: %d\n", total_recv);
	printf("Total bytes sent: %d\n", total_sent);
	
	close(ns);
}
