#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <pcap.h>
#include <netinet/ip.h>
#include <netinet/udp.h>

#ifndef _PEEKABOO_H_
#define _PEEKABOO_H_

#define SNAPLEN 128
#define PROMISC 0
#define TIMEOUT 500
#define FILTER "udp and port 4331"

#define ETHER_ADDR_LEN 14

struct ritas_rc_header {
	u_short pid;
};
typedef struct ritas_rc_header ritas_rc_header_t;
#define RITAS_RC_HEADER_SIZE 2

struct ritas_id_header {
#define RITAS_ID_BC 	0x01
#define RITAS_ID_MVC	0x02
#define RITAS_ID_VC		0x04
#define RITAS_ID_AB		0x08
	u_char flags;
	u_char mvcid;
	u_short cid;
	u_short txid;
	u_short rbid;
};
typedef struct ritas_id_header ritas_id_t;
#define RITAS_ID_HEADER_SIZE 8

struct ritas_rb_header {
	ritas_id_t id;
	u_short type;
#define RITAS_RB_INITIAL	0x00
#define RITAS_RB_ECHO		0x01
#define RITAS_RB_READY		0x02
}; 
typedef struct ritas_rb_header ritas_rb_header_t;
#define RITAS_RB_HEADER_SIZE (RITAS_ID_HEADER_SIZE + 2)

struct ritas_bc_header {
	u_short step;
	u_short round;
	u_char value;
}; 
typedef struct ritas_bc_header ritas_bc_header_t;
#define RITAS_BC_HEADER_SIZE 5

#endif //_PEEKABOO_H_
