#ifndef RITAS_RC_UNACK_H
#define RITAS_RC_UNACK_H

#include <sys/types.h>
#include "ritas_mbuf.h"
#include "ritas_group.h"

/*
 * The proc-mbuf tuple to hold an unacknowledged packet.
 */
struct ritas_rc_unack {
	ritas_mbuf_t *mbuf;	/* the mbuf for whom we're waiting ack */
	struct ritas_process *proc;	/* the process for whom we're waiting ack */
	float rto;			/* the current RTO for this proc-mbuf tuple */
	u_int nrexmt;		/* the number of times retransmitted: 0, 1, 2, ... */
};
typedef struct ritas_rc_unack ritas_rc_unack_t;

#define RITAS_RC_UNACK_HASH(proc, sn)	\
	proc->addr.sin_addr.s_addr ^ (sn + ((u_int)proc->addr.sin_port))

ritas_rc_unack_t *ritas_rc_unack_init(struct ritas_process *proc, ritas_mbuf_t *mbuf);
void ritas_rc_unack_destroy(ritas_rc_unack_t *pm);

#endif	/* RITAS_RC_UNACK_H */
