#ifndef RITAS_AB_AHT
#define RITAS_AB_AHT

#include "ritas_mbuf.h"
#include "ritas_ht.h"
#include "ritas_list.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

/*
 * Augmented Hash Table for Atomic Broadcast.
 */
struct ritas_ab_aht {
#define RITAS_AB_AHT_HT_SIZE 251
	ritas_ht_t *ht;
	ritas_list_t *l;
};
typedef struct ritas_ab_aht ritas_ab_aht_t;

struct ritas_ab_aht_list_entry {
	struct ritas_ab_aht_list_entry *prev;
	struct ritas_ab_aht_list_entry *next;
	ritas_mbuf_t *m;
};
typedef struct ritas_ab_aht_list_entry ritas_ab_aht_list_entry_t;

typedef ritas_ht_entry_t ritas_ab_aht_entry_t;
 

ritas_ab_aht_t *ritas_ab_aht_init();
void ritas_ab_aht_destroy(ritas_ab_aht_t *aht);
void ritas_ab_aht_renew(ritas_ab_aht_t *aht);

ritas_ab_aht_list_entry_t *ritas_ab_aht_list_entry_init();
void ritas_ab_aht_list_entry_destroy(ritas_ab_aht_list_entry_t *le);
 
int ritas_ab_aht_insert(ritas_ab_aht_t *aht, u_char *hash, u_short hash_s, ritas_mbuf_t *m);
void ritas_ab_aht_update(ritas_ab_aht_entry_t *e, ritas_mbuf_t *m);
void *ritas_ab_aht_remove(ritas_ab_aht_t *aht, u_char *hash, u_short hash_s);
ritas_ab_aht_entry_t *ritas_ab_aht_lookup(ritas_ab_aht_t *aht, u_char *hash, u_short hash_s);

ritas_list_t *ritas_ab_aht_list(ritas_ab_aht_t *aht);

#endif /* RITAS_AB_AHT */
