#ifndef RITAS_AB_H
#define RITAS_AB_H

#include <pthread.h>
#include "ritas.h"
#include "ritas_ab_aht.h"
#include "ritas_proc.h"
#include "ritas_mbuf.h"
#include "ritas_aproxy.h"
#include "ritas_vector.h"
#include "ritas_ht.h"
#include "ritas_rb.h"
#include "ritas_vc.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

struct ritas_abcb {
	u_short id;
	u_short vcid;
	u_char lock;
	u_char decision;
	
	ritas_vccb_t *vccb;
#define RITAS_AB_THROUGHPUT 10
	ritas_rbcb_t **rbcb;
	u_short *rb_num;
	u_short rbcb_count;
	ritas_list_t *rbcb_l;
	pthread_mutex_t rbcb_mutex;
	pthread_cond_t rbcb_cond;

	u_char a_running;
	ritas_list_t *a_delivered;
	pthread_t a_thread;
	pthread_mutex_t a_delivered_mutex;
	pthread_cond_t a_delivered_cond;
	
	ritas_ab_aht_t *a_aht;
	u_short a_count;

	ritas_ab_aht_t *r_aht;	
	int r_count;

#define RITAS_AB_V_COUNT_SIZE 7	
	ritas_ht_t *v_count;
};
typedef struct ritas_abcb ritas_abcb_t;

struct ritas_ab_header {
	u_short txid;
	u_short num;
};
typedef struct ritas_ab_header ritas_ab_header_t;

struct ritas_ab_vproc {
	u_short count;
	u_char *proc;
};
typedef struct ritas_ab_vproc ritas_ab_vproc_t;

int ritas_ab_init(ritas_t *ctx);
void ritas_ab_destroy(ritas_t *ctx);
int ritas_ab_consensus(ritas_t *ctx, ritas_abcb_t *cb);
int ritas_ab_input(ritas_t *ctx, ritas_abcb_t *cb, ritas_mbuf_t *m);
int ritas_ab_output(ritas_t *ctx, ritas_abcb_t *cb, ritas_mbuf_t *m);
ritas_ab_vproc_t *ritas_ab_vproc_init(u_short n);
void ritas_ab_vproc_destroy(ritas_ab_vproc_t *vproc);
int ritas_ab_bcast(ritas_t *ctx, u_char *buf, u_short buf_s);
int ritas_ab_recv(ritas_t *ctx, u_char *buf, u_short buf_s);
u_short ritas_ab_id(ritas_abcb_t *cb);

#endif /* RITAS_AB_H */
