#include <stdlib.h>
#include <pthread.h>
#include "ritas_aproxy.h"

int ritas_aproxy_init(ritas_t *ctx) {

	int n;

	ctx->aproxy = malloc(sizeof(ritas_aproxy_t));
	if(!ctx->aproxy) {
		return -1;
	}

	printf("APROXY=%p\n", ctx->aproxy);

	pthread_mutex_init(&ctx->aproxy->mutex, NULL);
	n = pthread_cond_init(&ctx->aproxy->cond, NULL);	
	if(n) {
		pthread_mutex_destroy(&ctx->aproxy->mutex);
		return -1;
	}
	
	ctx->aproxy->count = 0;
	ctx->aproxy->mvalue = NULL;
	return 1;
}

void ritas_aproxy_destroy(ritas_t *ctx) {
	
	if(ctx->aproxy) {
		pthread_cond_destroy(&ctx->aproxy->cond);
		pthread_mutex_destroy(&ctx->aproxy->mutex);
		if(ctx->aproxy->mvalue)
			ritas_mbuf_destroy(ctx->aproxy->mvalue);
		free(ctx->aproxy);
		ctx->aproxy = NULL;
	}
}
