#include "ritas_bc.h"
#include "ritas_bc_bracha.h"
//#include "ritas_bc_abba.h"

ritas_bccb_t *ritas_bc_init(ritas_t *ctx, u_short id, void *parent) {
	
	switch ctx->protocol[RITAS_BC] {
		
		case RITAS_BC_BRACHA:
		return ritas_bc_bracha_init(ctx, id, parent);

		//case RITAS_BC_ABBA:
		// TODO: thcoin and thsig initialization code goes here
		// all the messy stuff is handled by these proxy functions,
		// all the rest is transparent
		//return ritas_bc_abba_init(ctx, id, parent, thcoin, thsig);
	
		default:
		return NULL;	
	}
}
	
void ritas_bc_destroy(ritas_t *ctx, ritas_bccb_t *bccb) {
	
	switch ctx->protocol[RITAS_BC] {
		
		case RITAS_BC_BRACHA:
		ritas_bc_bracha_destroy(ctx, (ritas_bccb_bracha_t *)bccb);
		break;
		
		//case RITAS_BC_ABBA:
		//ritas_bc_abba_destroy(ctx, (ritas_bccb_abba_t *)bccb);
		//break;
		
		default:
		break;
	}
}
	
int ritas_bc_input(ritas_t *ctx, ritas_bccb_t *bccb, ritas_mbuf_t *m) {
	
	switch ctx->protocol[RITAS_BC] {
		
		case RITAS_BC_BRACHA:
		return ritas_bc_input(ctx, (ritas_bccb_bracha_t *)bccb, m);
		
		//case RITAS_BC_ABBA:
		//return ritas_bc_input(ctx, (ritas_bccb_abba_t *)bccb, m);
		
		default:
		return -1;
	}
}

	
int ritas_bc_output(ritas_t *ctx, ritas_bccb_t *bccb, ritas_mbuf_t *m) {
	
	switch ctx->protocol[RITAS_BC] {
		
		case RITAS_BC_BRACHA:
		return ritas_bc_output(ctx, (ritas_bccb_bracha_t *)bccb, m);
		
		//case RITAS_BC_ABBA:
		//return ritas_bc_output(ctx, (ritas_bccb_abba_t *)bccb, m);
		
		default:
		return -1;
	}
}
	
int ritas_bc(ritas_t *ctx, u_short bcid, u_char proposal);

u_short ritas_bc_id(ritas_bccb_t *bccb) {

	switch ctx->protocol[RITAS_BC] {
		
		case RITAS_BC_BRACHA:
		return (ritas_bccb_bracha_t *)bccb->id;
		
		//case RITAS_BC_ABBA:
		//return (ritas_bccb_abba_t *)bccb->id;
		
		default:
		return -1;
	}
}

void *ritas_bc_parent(ritas_bccb_t *bccb) {
	
	switch ctx->protocol[RITAS_BC] {
		
		case RITAS_BC_BRACHA:
		return (ritas_bccb_bracha_t *)bccb->parent;
		
		//case RITAS_BC_ABBA:
		//return (ritas_bccb_abba_t *)bccb->parent;
		
		default:
		return -1;
	}
}
