#ifndef RITAS_BC_ABBA_H
#define RITAS_BC_ABBA_H

#include "ritas.h"
#include "ritas_mbuf.h"
#include "ritas_proc.h"
#include "ritas_ht.h"
#include "ritas_aproxy.h"
#include "ritas_rb.h"
#include "ritas_eb.h"
#include "ritas_thsig.h"
#include "ritas_thcoin.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

#define RITAS_BC_ZERO		0
#define RITAS_BC_ONE		1
#define RITAS_BC_DEFAULT	2
#define RITAS_BC_TOTAL		3

struct ritas_bc_abba_prevote_just {
	u_short type[2];
	u_short size[2];
	u_char *data[2];
};
typedef struct ritas_bc_abba_prevote_just ritas_bc_abba_prevote_just_t;


struct ritas_bccb_abba {
	u_short id;
	u_short round;
	u_short step;
	u_char upper;
	void *parent;
	ritas_rccb_t *rccb;
	ritas_rccb_t *rccb_pre;

	ritas_thcoin_t *thcoin;
	ritas_thsig_t *thsig;
	
	u_char **preprocess_share[2];
	u_short preprocess_share_count[2];
	u_char **prevote_share[2];
	u_short prevote_share_count[2];
	u_char **mainvote_share[3];

	ritas_bc_abba_prevote_just_t *pvjp, *pvjp_rm1;
	ritas_bc_abba_prevote_just_t pvj[2];
	
	u_short coin_share_count;
	
	u_short vcount[4];
	u_char coin_flip;
	u_char decision;
};
typedef struct ritas_bccb_abba ritas_bccb_t;

struct ritas_bc_abba_header {
	u_short type;
#define RITAS_BC_ABBA_PREPROCESS	1
#define RITAS_BC_ABBA_PREVOTE		2
#define RITAS_BC_ABBA_MAINVOTE		3
#define RITAS_BC_ABBA_COIN			4
	u_short subtype;
#define RITAS_BC_ABBA_PREVOTE_ROUND_ONE	1
#define RITAS_BC_ABBA_PREVOTE_HARD		2
#define RITAS_BC_ABBA_PREVOTE_SOFT		3	
	u_short round;
	u_char value;
	u_char share[RITAS_THSIG_SHARE_SIZE];
}; 
typedef struct ritas_bc_abba_header ritas_bc_abba_header_t;
#define RITAS_BC_ABBA_HEADER_SIZE (7 + RITAS_THSIG_SHARE_SIZE)

struct ritas_bc_abba_coin_header {
	u_short type;
	u_short round;
	u_char share[RITAS_THCOIN_SHARE_SIZE];
};
typedef struct ritas_bc_abba_coin_header ritas_bc_abba_coin_header_t;
#define RITAS_BC_ABBA_COIN_HEADER_SIZE (4 + RITAS_THCOIN_SHARE_SIZE)


ritas_bccb_t *ritas_bc_init(ritas_t *ctx, u_short id, void *parent);
void ritas_bc_destroy(ritas_t *ctx, ritas_bccb_t *bccb);

int ritas_bc_abba_input(ritas_t *ctx, ritas_bccb_t *bccb, ritas_mbuf_t *m);
int ritas_bc_abba_output(ritas_t *ctx, ritas_bccb_t *bccb, ritas_mbuf_t *m);
int ritas_bc(ritas_t *ctx, u_short bcid, u_char proposal);

int ritas_bc_abba_verify_share(ritas_bccb_t *bccb, u_char *share, u_short type, u_short round, u_char value, u_short pid);
int ritas_bc_abba_verify(ritas_bccb_t *bccb, u_char *sig, u_short sig_size, u_short k, u_short type, u_short round, u_char value);
int ritas_bc_abba_share(ritas_bccb_t *bccb, u_char *buf, u_short type, u_short round, u_char value);

u_short ritas_bc_id(ritas_bccb_t *bccb);
void *ritas_bc_parent(ritas_bccb_t *bccb);

int ritas_bc_multi(ritas_t *ctx, u_short bcid, u_char proposal, u_short n_prop);

#endif /* RITAS_BC_ABBA_H */
