#ifndef RITAS_AZ_H
#define RITAS_AZ_H

#include "ritas.h"
#include "ritas_mbuf.h"
#include "ritas_proc.h"
#include "ritas_ht.h"
#include "ritas_aproxy.h"
#include "ritas_rb.h"
#include "ritas_eb.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

#define RITAS_BC_ZERO		0
#define RITAS_BC_ONE		1
#define RITAS_BC_DEFAULT	2
#define RITAS_BC_TOTAL		3

struct ritas_azcb {
	u_short id;
	u_short phase;
	u_short status;
#define RITAS_AZ_UNDECIDED 0	
#define RITAS_AZ_DECIDED 1
	u_char upper;
	void *parent;
#define RITAS_BC_VTABLE_SIZE 7
	u_short invalid[3][3];
	u_short valid[3][4];
	
	u_char decided;
	u_char terminated;
};
typedef struct ritas_bccb ritas_bccb_t;


struct ritas_az_header {
	u_short step;
	u_short round;
	u_char value;
}; 
typedef struct ritas_az_header ritas_az_header_t;
#define RITAS_AZ_HEADER_SIZE 5

ritas_bccb_t *ritas_bc_init(ritas_t *ctx, u_short id, void *parent);
void ritas_bc_destroy(ritas_t *ctx, ritas_bccb_t *bccb);
int ritas_bc_input(ritas_t *ctx, ritas_bccb_t *bccb, ritas_mbuf_t *m);
int ritas_bc_output(ritas_t *ctx, ritas_bccb_t *bccb, ritas_mbuf_t *m);
int ritas_bc(ritas_t *ctx, u_short bcid, u_char proposal);
u_short ritas_bc_id(ritas_bccb_t *bccb);
void *ritas_bc_parent(ritas_bccb_t *bccb);
int ritas_bc_N(ritas_t *ctx, ritas_bccb_t *bccb, u_short k, u_char b);

#endif /* RITAS_BC_BRACHA_H */
