#ifndef RITAS_EB_H
#define RITAS_EB_H

#include "ritas.h"
#include "ritas_rc.h"
#include "ritas_vector.h"
#include "ritas_mbuf.h"

struct ritas_ebcb {
	u_short txid;
	u_short rbid;
	u_char step;
#define RITAS_EB_SENDER		1
#define RITAS_EB_RECEIVER	2
	u_char role;
	u_char **matrix;
	u_char count;
	ritas_mbuf_t *m;
#define RITAS_EB_UPPER_BC	1
#define RITAS_EB_UPPER_MVC	2
#define RITAS_EB_UPPER_VC	3
#define RITAS_EB_UPPER_AB	4	
	u_char upper;
	void *parent;
	ritas_rccb_t *rccb;
};
typedef struct ritas_ebcb ritas_ebcb_t;


struct ritas_eb_header {
	u_short type;
#define RITAS_EB_INITIAL	0x01
#define RITAS_EB_ECHO		0x02
#define RITAS_EB_COMMIT		0x03
};
typedef struct ritas_eb_header ritas_eb_header_t;
#define RITAS_EB_HEADER_SIZE (RITAS_ID_HEADER_SIZE + 2)

ritas_ebcb_t *ritas_eb_init(ritas_t *ctx, u_short txid, u_short id, void *parent, u_char parent_type);
void ritas_eb_destroy(ritas_t *ctx, ritas_ebcb_t *ebcb);
int ritas_eb_input(ritas_t *ctx, ritas_ebcb_t *ebcb, ritas_mbuf_t *m);
int ritas_eb_output(ritas_t *ctx, ritas_ebcb_t *ebcb, ritas_mbuf_t *m);
u_short ritas_eb_txid(ritas_ebcb_t *ebcb);
u_short ritas_eb_rbid(ritas_ebcb_t *ebcb);
void *ritas_eb_parent(ritas_ebcb_t *ebcb);
u_char ritas_eb_parent_type(ritas_ebcb_t *ebcb);
#endif /* RITAS_EB_H */
