#ifndef RITAS_LIST_H
#define RITAS_LIST_H
#ifdef MEMWATCH
#include "memwatch.h"
#endif

struct ritas_list {
	struct ritas_list_member *first;
	struct ritas_list_member *last;
};
typedef struct ritas_list ritas_list_t;

struct ritas_list_member {
	struct ritas_list_member *prev;
	struct ritas_list_member *next;
};
typedef struct ritas_list_member ritas_list_member_t;


ritas_list_t *ritas_list_init();
void ritas_list_destroy(ritas_list_t *l);
void ritas_list_destroy_mbuf(ritas_list_t *l);
int ritas_list_add(ritas_list_t *l, void *target, void *o);
void *ritas_list_remove(ritas_list_t *l, void *target);
int ritas_list_enqueue(ritas_list_t *l, void *o);
void *ritas_list_dequeue(ritas_list_t *l);
void *ritas_list_concat(ritas_list_t *l1, ritas_list_t *l2);

#endif /* RITAS_LIST_H */
