#ifndef RITAS_MBUF_H
#define RITAS_MBUF_H

#include <sys/types.h>
#include <pthread.h>
#include <openssl/md5.h>
#ifdef MEMWATCH
#include "memwatch.h"
#endif


/*
 * mbuf structure.
 * Used to pass packets among the various layers.
 */
struct ritas_mbuf {
	struct ritas_mbuf *prev;
	struct ritas_mbuf *next;
	u_char *head;
	u_char *tail;
#define RITAS_MBUF_RB 	1
#define RITAS_MBUF_BC 	2
#define RITAS_MBUF_MVC	3
#define RITAS_MBUF_VC	4
#define RITAS_MBUF_AB	5
	struct ritas_process *proc;
	struct ritas_rbcb *rbcb;
	u_char protocol;
#define RITAS_MBUF_PROTECTED 	0x01	/* Protected. Mbuf will not be destroyed. */
#define RITAS_MBUF_EXT			0x02	/* external payload */
	u_char flags;
	struct ritas_id_header *id;
//#define RITAS_MBUF_DATA_SIZE 16384
#define RITAS_MBUF_DATA_SIZE 8192
	u_char data[RITAS_MBUF_DATA_SIZE];
};
typedef struct ritas_mbuf ritas_mbuf_t;

ritas_mbuf_t *ritas_mbuf_init();
void ritas_mbuf_destroy(ritas_mbuf_t *m);

#endif /* RITAS_MBUF_H */
