#ifndef RITAS_PROC_H
#define RITAS_PROC_H

#include <netinet/in.h>
#include <openssl/md5.h>
#include "ritas.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

#define RITAS_KEY_SIZE MD5_DIGEST_LENGTH

/*
 * Group management structure.
 * Maintains information such as the network
 * addresses for each process belonging to the group.
 */
struct ritas_process {
	u_short id;
	struct sockaddr_in addr;
	u_char key[RITAS_KEY_SIZE];
	u_char key_s;
#ifdef TCP
	int socket;
#endif	
};
typedef struct ritas_process ritas_proc_t;

int ritas_proc_add_ipv4(ritas_t *ctx, u_short pid, u_char *ip, u_short port, u_char *key);
int ritas_proc_add_sockaddr_in(ritas_t *ctx, u_short pid, struct sockaddr_in *addr, u_char *key);
ritas_proc_t *ritas_proc_get(ritas_t *ctx, u_short pid);
int ritas_group_size(ritas_t *ctx);

#endif /* RITAS_PROC_H */
