#ifndef RITAS_THCOIN_H
#define RITAS_THCOIN_H

#include "ritas.h"

#define RITAS_THCOIN_NAME_MAX 16
#define RITAS_THCOIN_KEY_SIZE 160
#define RITAS_THCOIN_KEY_SIZE_BYTES (RITAS_THCOIN_KEY_SIZE/8)
#define RITAS_THCOIN_MOD_SIZE 1024
#define RITAS_THCOIN_MOD_SIZE_BYTES (RITAS_THCOIN_MOD_SIZE/8)
#define RITAS_THCOIN_SHARE_SIZE (RITAS_THCOIN_KEY_SIZE_BYTES + RITAS_THCOIN_MOD_SIZE_BYTES*2)

struct ritas_thcoin {
	u_char coin_name[RITAS_THCOIN_NAME_MAX];
	u_short coin_name_s;
	u_short id;
	u_short n;
	u_short k;

	u_char **share;
	
	BIGNUM *p, *q, *g;	// Global verification key
	BIGNUM **gi;		// Local verification keys
	BIGNUM *xi;			// Secret keys
	BIGNUM *_g;
};
typedef struct ritas_thcoin ritas_thcoin_t;

ritas_thcoin_t *ritas_thcoin_init_bn(u_short id, u_short n, u_short k);
void ritas_thcoin_destroy(ritas_thcoin_t *thcoin);
int ritas_thcoin_reset(ritas_thcoin_t *coin, u_char *coin_name, u_short coin_name_s);

int ritas_thcoin_generate_share(ritas_thcoin_t *coin, u_char *share);
int ritas_thcoin_verify_share(ritas_thcoin_t *coin, u_char *share, u_short id);
int ritas_thcoin_add_share(ritas_thcoin_t *coin, u_char *share, u_short id);
int ritas_thcoin_combine_shares(ritas_thcoin_t *coin);

#endif /* RITAS_THCOIN_H */
