#ifndef RITAS_THSIG_H
#define RITAS_THSIG_H

#include "ritas.h"
#include <openssl/rsa.h>

#define RITAS_THSIG_SHARE_SIZE 128

struct ritas_thsig {
	u_short id;
	u_short n;
	u_short k;
	RSA *private_key;
	RSA **public_key;
	u_char *data;	
	u_short data_s;
	u_short offset;
	u_char **share;
	u_short share_count;
};
typedef struct ritas_thsig ritas_thsig_t;



ritas_thsig_t *ritas_thsig_init_ms(u_short mypid, u_short n);
void ritas_thsig_destroy(ritas_thsig_t *thsig);
int ritas_thsig_reset(ritas_thsig_t *thsig, u_short data_s);
int ritas_thsig_update(ritas_thsig_t *thsig, const u_char *data, u_int data_s);

int ritas_thsig_generate_share(ritas_thsig_t *thsig, u_char *share);
int ritas_thsig_verify_share(ritas_thsig_t *thsig, u_char *share, u_short id);
int ritas_thsig_verify(ritas_thsig_t *thsig, u_char *sig, u_short sig_size, u_short k);
int ritas_thsig_add_share(ritas_thsig_t *thsig, u_char *share, u_short id);
int ritas_thsig_combine_shares(ritas_thsig_t *thsig, u_short k, u_char *sig);

int ritas_thsig_sigsize(u_short k);
#endif /* RITAS_THSIG_H */
