#ifndef RITAS_VC_H
#define RITAS_VC_H

#include "ritas.h"
#include "ritas_aproxy.h"
#include "ritas_mbuf.h"
#include "ritas_rb.h"
#include "ritas_mvc.h"
#ifdef MEMWATCH
#include "memwatch.h"
#endif

struct ritas_vccb {
	u_short id;
	ritas_rbcb_t **rbcb;
	ritas_mvccb_t *mvccb;
	u_char upper;
	void *parent;
	u_short round;
	u_char lock;
	ritas_mbuf_t **W;
	u_short count;
#define RITAS_VC_V_COUNT_SIZE 7	
	ritas_ht_t *v_count;
};
typedef struct ritas_vccb ritas_vccb_t;

struct ritas_vc_vproc {
	u_short count;
	u_char *proc;
};
typedef struct ritas_vc_vproc ritas_vc_vproc_t;

ritas_vccb_t *ritas_vc_init(ritas_t *ctx, u_short cid, void *parent);
void ritas_vc_destroy(ritas_t *ctx, ritas_vccb_t *cb);
int ritas_vc_input(ritas_t *ctx, ritas_vccb_t *cb, ritas_mbuf_t *m);
int ritas_vc_output(ritas_t *ctx, ritas_vccb_t *cb, ritas_mbuf_t *m);
int ritas_vc(ritas_t *ctx, u_short cid, u_char *vec, u_short vec_size, u_char *decision, u_short decision_size);
ritas_vc_vproc_t *ritas_vc_vproc_init(u_short n);
void ritas_vc_vproc_destroy(ritas_vc_vproc_t *vproc);
u_short ritas_vc_id(ritas_vccb_t *cb);
void *ritas_vc_parent(ritas_vccb_t *cb);
#endif /* RITAS_VC_H */
