#include <stdlib.h>
#include <string.h>
#include "ritas_vector.h"

ritas_vector_t *ritas_vector_init(u_short maxsize) {
	
	ritas_vector_t *vector;
	
	vector = malloc(sizeof(ritas_vector_t));
	if(!vector)
		goto bad;
	
	vector->element = NULL;
	vector->element_s = NULL;
	
	vector->size = 0;
	vector->maxsize = maxsize;
	vector->data_s = sizeof(vector->size);
	vector->element = malloc(maxsize*sizeof(u_char *));
	if(!vector->element)
		goto bad;
	vector->element_s = malloc(maxsize*sizeof(u_short));
	if(!vector->element_s)
		goto bad;
	
	return vector;

bad:
	ritas_vector_destroy(vector);
	return NULL;
}


void ritas_vector_destroy(ritas_vector_t *vector) {
	if(vector) {
		free(vector->element);
		free(vector->element_s);
		free(vector);
	}
}


ritas_vector_t *ritas_vector_extract(u_char *data, u_short data_s) {
	
	int i;
	int offset;
	ritas_vector_t *vector;

	vector = ritas_vector_init(*(u_short *)data);
	if(!vector)
		return NULL;

	vector->size = *(u_short *)data;

	offset = sizeof(vector->size);
	for(i = 0 ; i < vector->size ; i++) {	
		vector->element_s[i] = *(u_short *)(data + offset);
		offset += sizeof(vector->element_s[i]);
		
		if(offset > data_s)
			return vector;
		
		if(vector->element_s[i] > 0) {
			vector->element[i] = data + offset;
			offset += vector->element_s[i];
		
			if(offset > data_s)
				return vector;
		}
		else
			vector->element[i] = NULL;
	}
	
	return vector;
}


int ritas_vector_add(ritas_vector_t *vector, u_char *buf, u_short buf_s) {
	
	if(!vector)
		return 1;
	
	if(vector->size >= vector->maxsize)
		return -1;
	
	vector->element_s[vector->size] = buf_s;
	if(buf_s > 0) {
		vector->element[vector->size] = buf;
	}
	else
		vector->element[vector->size] = NULL;

	vector->data_s += vector->element_s[vector->size] + sizeof(vector->element_s[vector->size]);
	vector->size++;
	
	return 1;
}

void ritas_vector_build(ritas_vector_t *vector, u_char *buf) {

	int i;
	int offset;
	
	if(!vector)
		return;
	
	memcpy(buf, &vector->size, sizeof(vector->size));
	offset = sizeof(vector->size);
	for(i = 0 ; i < vector->size ; i++) {
		memcpy(buf + offset, &vector->element_s[i], sizeof(vector->element_s[i]));
		offset += sizeof(vector->element_s[i]);

		if(vector->element_s[i] > 0) {
			memcpy(buf + offset, vector->element[i], vector->element_s[i]); 
			offset += vector->element_s[i];
		}
	}
	return;
}
