#ifndef RITAS_VECTOR_H
#define RITAS_VECTOR_H

#include <sys/types.h>
#ifdef MEMWATCH
#include "memwatch.h"
#endif

struct ritas_vector {
	u_short size;
	u_short maxsize;
	u_char **element;
	u_short *element_s;
	u_short data_s;
};
typedef struct ritas_vector ritas_vector_t;

/*
 * Initializes an empty vector structure able to hold up to maxsize elements.
 */
ritas_vector_t *ritas_vector_init(u_short maxsize);

/*
 * Extracts vector information from a contiguos memory buffer into a vector
 * structure.
 */
ritas_vector_t *ritas_vector_extract(u_char *data, u_short data_s);

/*
 * Destroys a vector structure.
 */
void ritas_vector_destroy(ritas_vector_t *vector);

/*
 * Adds a value to the vector structure.
 */
int ritas_vector_add(ritas_vector_t *vector, u_char *buf, u_short buf_s);

/*
 * Builds a vector onto a contiguos memory buffer based on the information from
 * the vector structure.
 */
void ritas_vector_build(ritas_vector_t *vector, u_char *buf);

#endif /* RITAS_VECTOR_H */
