#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/*
 * Test suite for RITAS
 */
int main(int argc, char **argv) {
	
	u_char buf[8];
	struct sockaddr_in addr, peeraddr;
	socklen_t addr_s;
	int sock, ns;
	int i, n;
	fd_set set;
	
	sock = socket(AF_INET, SOCK_STREAM, 0);	
	
	memset(&addr, '\0', sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(atoi(argv[1]));
	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	
	n = bind(sock, (struct sockaddr *)&addr, sizeof(addr));
	if(n < 0) {
		perror("bind");
		exit(1);
	}
	n = listen(sock, 5);
	if(n < 0) {
		perror("listen");
		exit(1);
	}
	addr_s = sizeof(addr);
	ns = accept(sock, (struct sockaddr *)&addr, &addr_s);
	if(ns < 0) {
		perror("accept");
		exit(1);
	}	
	

	for(i = 1 ; i < 10 ; i++) {
		FD_ZERO(&set);
		FD_SET(ns, &set);
		printf("%d - blocking on select()\n", i);
		n = select(ns+1, &set, NULL, NULL, NULL);
		if(n < 0) {
			perror("select");
			exit(1);
		}
		if(FD_ISSET(ns, &set)) {
			n = recv(ns, buf, 8, 0);
			printf("%d - received %d bytes\n", i, n);
		}
		sleep(5);
	}
}
