#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>

int main(int argc, char **argv) {

	int s, n;
	int recvbuf;
	socklen_t optlen;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	if(s < 0) {
        printf("%s(): socket()\n", __func__);
		exit(1);
	}
	
	optlen = sizeof(recvbuf);

	if(argc > 1) {
		recvbuf = atoi(argv[1]);
		n = setsockopt(s, SOL_SOCKET, SO_RCVBUF, &recvbuf, optlen);
		if(n < 0) {
    	    printf("%s(): setsockopt()\n", __func__);
			exit(1);
		}

	}

	n = getsockopt(s, SOL_SOCKET, SO_RCVBUF, &recvbuf, &optlen);
	if(n < 0) {
   	    printf("%s(): getsockopt()\n", __func__);
		exit(1);
	}

	printf("SO_RCVBUF: %d bytes\n", recvbuf);
	
	close(s);

}
