#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include "ritas_thcoin_keys.h"
#include "ritas_thcoin.h"

int main() {
	
	ritas_thcoin_t *coin;
	int i, j, r; 
	u_char share[4][2*RITAS_THCOIN_KEY_SIZE/8 + RITAS_THCOIN_MOD_SIZE/8];
	u_char coin_name;
	u_short id;

	coin = ritas_thcoin_init_bn(2, 4, 3);

	for(i = 0 ; i < 10000 ; i++) {

	id = 2;
	coin_name = id << sizeof(id)*8;
	r = ritas_thcoin_reset(coin, (u_char *)&coin_name, sizeof(coin_name));
	if(r < 0) {
		printf("ritas_thcoin_reset()\n");
		exit(1);
	}

	r = ritas_thcoin_generate_share(coin, share[0]);
	if(r < 0) {
		printf("ritas_thcoin_generate_share()\n");
		exit(1);
	}

	r = ritas_thcoin_verify_share(coin, share[0], 2);
	if(r < 0) {
		printf("ritas_thcoin_verify_share()\n");
		exit(1);
	}
	else if(r == 1) {
		//printf("%u coin share verification ok!\n", id);
	}
	else {
		printf("%c coin share verification failed!\n", coin_name);
	}
	}
	ritas_thcoin_destroy(coin);
}
