#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include "ritas_thcoin_keys.h"
#include "ritas_thcoin.h"

#define COIN_NAME "tin omen"

int main() {
	
	ritas_thcoin_t *coin[4];
	u_char gvk[RITAS_THCOIN_KEY_SIZE/8 + 2*RITAS_THCOIN_MOD_SIZE/8];
	int i, j, r;
	BIGNUM *p, *q, *g, *gi, *xi;	 
	u_char share[4][2*RITAS_THCOIN_KEY_SIZE/8 + RITAS_THCOIN_MOD_SIZE/8];
	BIGNUM *tmp;

	for(i = 0 ; i < 4 ; i++) {
		coin[i] = ritas_thcoin_init_bn(i, 4, 3);
		if(!coin[i]) {
			printf("ritas_thcoin_init_bn()\n");
			exit(1);
		}
		
		r = ritas_thcoin_reset(coin[i], (u_char *)COIN_NAME, strlen(COIN_NAME));
		if(r < 0) {
			printf("ritas_thcoin_reset()\n");
			exit(1);
		}

		r = ritas_thcoin_generate_share(coin[i], share[i]);
		if(r < 0) {
			printf("ritas_thcoin_generate_share()\n");
			exit(1);
		}
		
	}
	
	for(j = 0 ; j < 4 ; j++) {
		r = ritas_thcoin_verify_share(coin[0], share[j], j);
		if(r < 0) {
			printf("ritas_thcoin_verify_share()\n");
			exit(1);
		}
		else if(r == 1) {
			printf("coin share verification ok!\n");
		}
		else {
			printf("coin share verification failed!\n");
		}
		
		for(i = 0 ; i < 4 ; i++) {
			if(i != j) {
				r = ritas_thcoin_add_share(coin[i], share[j], j);
				if(r < 0) {
					printf("ritas_thcoin_add_share()\n");
					exit(1);
				}
			}
		}
	}
	
	for(i = 0 ; i < 4 ; i++) {
		r = ritas_thcoin_combine_shares(coin[i]);
		printf("%d\n", r);
	}
	
	for(j = 0 ; j < 4 ; j++) {
		ritas_thcoin_destroy(coin[j]);
	}	
}
