#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
//#include <dmalloc.h>
#include "ritas_thsig.h"

int main() {

	ritas_thsig_t *thsig[4];
	u_char share[4][RITAS_THSIG_SHARE_SIZE];
	u_char buf[4*RITAS_THSIG_SHARE_SIZE];
	u_int sigsize;
	int i, k, n, r;
	
	n = 4;
	k = 3;
	
	for(i = 0 ; i < n ; i++) {
	
		thsig[i] = ritas_thsig_init_ms(i, 4);
		if(!thsig[i]) {
			printf("FAILED RITAS_THSIG_INIT()!\n");
			exit(1);
		}
		
		r = ritas_thsig_reset(thsig[i], 100);
		if(r < 0) {
			printf("FAILED ritas_thsig_reset()\n");
			exit(1);
		}
		
		r = ritas_thsig_update(thsig[i], (u_char *)"teste", 5);	
		if(r < 0) {
			printf("FAILED ritas_thsig_update()\n");
			exit(1);
		}
		
		r = ritas_thsig_generate_share(thsig[i], share[i]); 
		if(r < 0) {
			printf("FAILED ritas_thsig_generate_share()\n");
			exit(1);
		}
	
	    r = ritas_thsig_verify_share(thsig[i], share[i], i);
	    if(r == 1)
	    	printf("Valid share! :)\n");
	    else if(r == 0)
	    	printf("Invalid share! :(\n");
	}
	
	
	for(i = 0 ; i < k ; i++) {
		r = ritas_thsig_add_share(thsig[0], share[i], i);
		if(r < 0) {
			printf("FAILED ritas_thsig_add_share()\n");
			exit(1);
		}
	}

	sigsize = ritas_thsig_combine_shares(thsig[0], 3, buf);
	if(sigsize < 0) {
		printf("FAILED ritas_thsig_combine_shares()\n");
		exit(1);
	}

	r = ritas_thsig_verify(thsig[0], buf, sigsize, 3);
	if(r == 1) {
		printf("Threshold signature verified correctly!\n");
	}
	else if(r == 0) {
		printf("Threshold signature is invalid!\n");
	}


	for(i = 0 ; i < n ; i++) {
		ritas_thsig_destroy(thsig[i]);
	}
	
}
